/********************************************************************************
* table oriented Parser for mathematical formulas								*
*																				*
* by Ansgar Schfer, (c)2002													*
*																				*
* ParseEvl.h																	*
*																				*
* contains stackmachine, internal												*
* function variable is x														*
*																				*
* Version:	V2.04																*
* Date:		01.11.2002															*
********************************************************************************/


#ifndef _PARSEEVL_H
#define _PARSEEVL_H

#include "modeldef.h"

#include "ParseInt.h"


extern double					EvaluateStackNOFUNC (tStackElement FAR *Element, tFormulaInt FAR *Formula);
extern double					EvaluateStackVAL (tStackElement FAR *Element, tFormulaInt FAR *Formula);
extern double					EvaluateStackFUNC2V (tStackElement FAR *Element, tFormulaInt FAR *Formula);
extern double					EvaluateStackFUNC1V (tStackElement FAR *Element, tFormulaInt FAR *Formula);
extern double					EvaluateStackX (tStackElement FAR *Element, tFormulaInt FAR *Formula);
extern double					EvaluateStackNONE (tStackElement FAR *Element, tFormulaInt FAR *Formula);

extern void						ClearStack (tFormulaInt FAR *Formula);
extern void						RestoreStack (tFormulaInt FAR *Formula);
extern tStackElementVal FAR		*push (tFormulaInt FAR *Formula);
extern tStackElementVal FAR		*pop (tFormulaInt FAR *Formula);
extern double					EvaluateStack (tStackElement FAR *Element, tFormulaInt FAR *Formula);


/*******************
 * Local variables *
 *******************/
/* evaluation stack */


#endif	/* _PARSEEVL_H */