#########################################################################
#	Application Independent Definations
#########################################################################

#########################################################################
#	Application							#

# use this name when a script creates *.pva,*.abs and *.dbg
TARGET=SHAREDLib

# PV Application Title (This name is displayed on PV Menu)
TITLE="SHAREDLib"

# ProgramVersion(EX. 0100->Ver1.00)
VERSION = 0101
LIBVERSION = 0100

# Application Sources (src\*.c)
FILE0=SHAREDlib

#									#
#########################################################################
################################################################
#  SHC INSTALLATION DIRECTORY SETTING
################################################################
TCDIR=c:\pvshcom\shc
#########################################################################
#	MAKE file for release application (MOD.1)
#########################################################################

#------------------------------------------------------------------------
# Tools									|
# SH C/C++ Compiler phase
PVSDK_BASE=C:\CASIO\PV3S1600

CC=$(TCDIR)\bin\shc.exe -messages

# SH Assembler
ASM=$(TCDIR)\bin\asmsh.exe

# OptLinker
LNK=$(TCDIR)\bin\optlnk.exe

# Set Header
SETHED=$(PVSDK_BASE)\TOOLS\sethead.exe

# Put Name
PUTNAME=$(PVSDK_BASE)\TOOLS\putname.exe

# End of Tools 								|
#------------------------------------------------------------------------
#------------------------------------------------------------------------
# PV system config							|
STARTUP = $(PVSDK_BASE)\system\obj\startapl.obj
SETUP = $(PVSDK_BASE)\system\obj\setup.obj
SECT = $(PVSDK_BASE)\system\obj\section.obj
SYSRAM = $(PVSDK_BASE)\system\obj\rsysram.obj
BOOTINF = $(PVSDK_BASE)\system\obj\bootinf.obj

LDIR= $(PVSDK_BASE)\lib\LibH
SYSSRCDIR = $(PVSDK_BASE)\system
LCOM_H="$(LDIR)\define.h" "$(LDIR)\LIBC.H" "$(LDIR)\L_LIBC.H" "$(LDIR)\L_define.h"
LLIB   ="$(PVSDK_BASE)\lib\libc.lib"
ADDLIB ="$(PVSDK_BASE)\lib\addlibc.lib"

HIDIR = $(PVSDK_BASE)\lib\hilib
HILIB = "$(HIDIR)\HiLIB.LIB"
SHCLIB ="$(TCDIR)\shclib.lib"

#Common setting for Library
SOURCES = sources.def
SUBCOM = $(PVSDK_BASE)\tools\Makefile.sub
SRCDIR = ..\src
#OUTDIR = release
OUTDIR = ..\lib\Hitachi
#BINOUTDIR = user_bin
INC="..\def","$(LDIR)","$(HIDIR)"
LNKINF0=$(LCOM_H) $(LLIB) $(ADDLIB) $(SHCLIB) $(STARTUP) $(SOURCES)
CCINF0=-include=$(INC) -subcommand=$(SUBCOM)
SETHEDINF=-vl$(LIBVERSION) -m1 -pA -o -bIicon\icon.bmp -bLicon\licon.bmp

PUTNAMEINF=-p0 -wp

# End of system config							|
#------------------------------------------------------------------------
# Description blocks
SHCENV : 
	set PATH=$(TCDIR)\bin
	set SHC_INC=$(TCDIR)\include
	set SHC_LIB=$(TCDIR)\bin
	set SHC_TMP=$(TCDIR)
USERALLOBJ=	\
	"$(OUTDIR)\$(FILE0).obj"

#									#
#########################################################################

#########################################################################
#	Application							#
!MESSAGE
!MESSAGE Executing SH C/C++ Compiler phase
!MESSAGE

"$(OUTDIR)\$(FILE0).obj" : "$(SRCDIR)\$(FILE0).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE0).c" -objectfile="$(OUTDIR)\$(FILE0).obj" $(CCINF0)

#									#
#########################################################################

#########################################################################
#	MAKE file for release application (MOD.2)
#########################################################################
# USER OPTIONS
SETHEDUINF =  -vp$(VERSION)
#########################################################################

ALLOBJ = $(USERALLOBJ)

all:	SHCENV \
	$(ALLOBJ) \
	"$(OUTDIR)\$(TARGET).lib"

#------------------------------------------------------------------------
!MESSAGE
!MESSAGE Executing OptLinker phase
!MESSAGE

"$(OUTDIR)\$(TARGET).lib" : $(ALLOBJ) $(LNKINF0)
	$(LNK) -subcommand=<<
form Library=U
noprelink
input $(ALLOBJ)
output "$(OUTDIR)\$(TARGET).lib"
exit
<<
	del $(OUTDIR)\$(TARGET).obj