#########################################################################
#	Application Independent Definations
#########################################################################

#########################################################################
#	Application							#

# use this name when a script creates *.pva,*.abs and *.dbg
TARGET=PVPlot

# PV Application Title (This name is displayed on PV Menu)
TITLE="PVPlot"

# ProgramVersion(EX. 0100->Ver1.00)
VERSION = 0309
LIBVERSION = 0100

# Application Sources (src\*.c)
FILE0=pvplot
FILE1=buttons
FILE2=pvplgrph
FILE3=xpanel
FILE4=ypanel
FILE5=ownkeyb

#									#
#########################################################################
################################################################
#  SHC INSTALLATION DIRECTORY SETTING
################################################################
TCDIR=c:\pvshcom\shc
#########################################################################
#	MAKE file for release application (MOD.1)
#########################################################################

#------------------------------------------------------------------------
# Tools									|
# SH C/C++ Compiler phase
PVSDK_BASE=c:\casio\pv3s1600

CC=$(TCDIR)\bin\shc.exe -messages

# SH Assembler
ASM=$(TCDIR)\bin\asmsh.exe

# OptLinker
LNK=$(TCDIR)\bin\optlnk.exe

# Set Header
SETHED=$(PVSDK_BASE)\TOOLS\sethead.exe

# Put Name
PUTNAME=$(PVSDK_BASE)\TOOLS\putname.exe

# End of Tools 								|
#------------------------------------------------------------------------
#------------------------------------------------------------------------
# PV system config							|
STARTUP = $(PVSDK_BASE)\system\obj\startapl.obj
SETUP = $(PVSDK_BASE)\system\obj\setup.obj
SECT = $(PVSDK_BASE)\system\obj\section.obj
SYSRAM = $(PVSDK_BASE)\system\obj\rsysram.obj
BOOTINF = $(PVSDK_BASE)\system\obj\bootinf.obj

LDIR= $(PVSDK_BASE)\lib\LibH
SYSSRCDIR = $(PVSDK_BASE)\system
LCOM_H="$(LDIR)\define.h" "$(LDIR)\LIBC.H" "$(LDIR)\L_LIBC.H" "$(LDIR)\L_define.h"
LLIB   ="$(PVSDK_BASE)\lib\libc.lib"
ADDLIB ="$(PVSDK_BASE)\lib\addlibc.lib"
OWNLIBH = ..\LIB\H
OWNLIBA = "..\LIB\HITACHI\GRAPHLIB.LIB"
OWNLIBB = "..\LIB\HITACHI\PARSELIB.LIB"
OWNLIBC = "..\LIB\HITACHI\SHAREDLIB.LIB"

HIDIR = $(PVSDK_BASE)\lib\hilib
HILIB = "$(HIDIR)\HiLIB.LIB"
SHCLIB ="$(TCDIR)\shclib.lib"

#Common setting for Application
SOURCES = sources.def
SUBCOM = $(PVSDK_BASE)\tools\Makefile.sub
SRCDIR = ..\src
OUTDIR = ..\release\HitachiSH3
BINOUTDIR = user_bin
INC="..\def","$(LDIR)","$(HIDIR)","$(OWNLIBH)"
LNKINF0=$(LCOM_H) $(OWNLIBA) $(OWNLIBB) $(OWNLIBC) $(LLIB) $(ADDLIB) $(SHCLIB) $(STARTUP) $(SOURCES)
CCINF0=-include=$(INC) -subcommand=$(SUBCOM)
SETHEDINF=-vl$(LIBVERSION) -m1 -pA -o -bI..\icon\icon.bmp -bL..\icon\licon.bmp

PUTNAMEINF=-p0 -wp

# End of system config							|
#------------------------------------------------------------------------
# Description blocks
SHCENV : 
	set PATH=$(TCDIR)\bin
	set SHC_INC=$(TCDIR)\include
	set SHC_LIB=$(TCDIR)\bin
	set SHC_TMP=$(TCDIR)
USERALLOBJ=	\
	"$(OUTDIR)\$(FILE0).obj" \
	"$(OUTDIR)\$(FILE1).obj" \
	"$(OUTDIR)\$(FILE2).obj" \
	"$(OUTDIR)\$(FILE3).obj" \
	"$(OUTDIR)\$(FILE4).obj" \
	"$(OUTDIR)\$(FILE5).obj"

#									#
#########################################################################

#########################################################################
#	Application							#
!MESSAGE
!MESSAGE Executing SH C/C++ Compiler phase
!MESSAGE

"$(OUTDIR)\$(FILE0).obj" : "$(SRCDIR)\$(FILE0).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE0).c" -objectfile="$(OUTDIR)\$(FILE0).obj" $(CCINF0)

"$(OUTDIR)\$(FILE1).obj" : "$(SRCDIR)\$(FILE1).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE1).c" -objectfile="$(OUTDIR)\$(FILE1).obj" $(CCINF0)

"$(OUTDIR)\$(FILE2).obj" : "$(SRCDIR)\$(FILE2).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE2).c" -objectfile="$(OUTDIR)\$(FILE2).obj" $(CCINF0)

"$(OUTDIR)\$(FILE3).obj" : "$(SRCDIR)\$(FILE3).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE3).c" -objectfile="$(OUTDIR)\$(FILE3).obj" $(CCINF0)

"$(OUTDIR)\$(FILE4).obj" : "$(SRCDIR)\$(FILE4).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE4).c" -objectfile="$(OUTDIR)\$(FILE4).obj" $(CCINF0)

"$(OUTDIR)\$(FILE5).obj" : "$(SRCDIR)\$(FILE5).C" $(LNKINF0)
	$(CC) "$(SRCDIR)\$(FILE5).c" -objectfile="$(OUTDIR)\$(FILE5).obj" $(CCINF0)

#									#
#########################################################################

#########################################################################
#	MAKE file for release application (MOD.2)
#########################################################################
# USER OPTIONS
SETHEDUINF =  -vp$(VERSION)
#########################################################################

ALLOBJ = $(USERALLOBJ)

all:	SHCENV \
	$(ALLOBJ) \
	"$(OUTDIR)\$(TARGET).pva"

#------------------------------------------------------------------------
!MESSAGE
!MESSAGE Executing OptLinker phase
!MESSAGE

"$(OUTDIR)\$(TARGET).rld" : $(ALLOBJ) $(LNKINF0)
	$(LNK) -subcommand=<<
form sectrel
noprelink
nomessage 
list "$(OUTDIR)\$(TARGET).map"
show symbol
nologo
input $(STARTUP)
input $(SETUP)
input $(SECT)
input $(SYSRAM)
input $(BOOTINF)
input $(ALLOBJ)
library $(OWNLIBA)
library $(OWNLIBB)
library $(OWNLIBC)
library $(LLIB)
library $(ADDLIB)
library $(HILIB)
library $(SHCLIB)
output "$(OUTDIR)\$(TARGET).rld"
exit
<<

#------------------------------------------------------------------------
!MESSAGE
!MESSAGE Create PV Application Binary Object phase
!MESSAGE

"$(TARGET).pva" : $(ALLOBJ) $(LNKINF0)
	$(SETHED) "$(OUTDIR)\$(TARGET).rld" "$(BINOUTDIR)\$(TARGET).pva" $(SETHEDINF) $(SETHEDUINF)
	$(PUTNAME) $(PUTNAMEINF) "$(BINOUTDIR)\$(TARGET).pva" $(TITLE)
	copy make\fin "$(BINOUTDIR)\fin"
