/********************************************************************************
* Keyboard definition for editing mathematical formulas							*
*																				*
* by Ansgar Schfer, (c)2002													*
*																				*
* ownkeyb.h																		*
*																				*
*																				*
* Version:	V1.0																*
* Date:		20.10.2002															*
********************************************************************************/


#ifndef _OWNKEYB_H
#define _OWNKEYB_H


#include "modeldef.h"


/* display position of own keyboard */
#define OWNKEYB_XPOS		0
#define OWNKEYB_YPOS		89


/* Object Codes for own keyboard, sorted to fit to parse table (to get function text) */
#define	OBJ_FAK				0xD000
#define	OBJ_PARENOPEN		0xD001
#define	OBJ_PARENCLOSE		0xD002
#define	OBJ_MULT			0xD003
#define	OBJ_ADD				0xD004
#define	OBJ_KOMMA			0xD005
#define	OBJ_SUB				0xD006
#define	OBJ_POINT			0xD007
#define	OBJ_DIVIDE			0xD008
#define	OBJ_ZERO			0xD009
#define	OBJ_ONE				0xD00a
#define	OBJ_TWO				0xD00b
#define	OBJ_THREE			0xD00c
#define	OBJ_FOUR			0xD00d
#define	OBJ_FIVE			0xD00e
#define	OBJ_SIX				0xD00f
#define	OBJ_SEVEN			0xD010
#define	OBJ_EIGHT			0xD011
#define	OBJ_NINE			0xD012
#define	OBJ_ABS				0xD013
#define	OBJ_ACOS			0xD014
#define	OBJ_ASIN			0xD015
#define	OBJ_ATAN			0xD016
#define	OBJ_COSH			0xD017
#define	OBJ_COS				0xD018
#define	OBJ_EXP				0xD019
#define	OBJ_CEULER			0xD01a

#define	OBJ_LN				0xD01c
#define	OBJ_LOG10			0xD01d
#define	OBJ_LOGXY			0xD01e
#define	OBJ_CPI				0xD01f
#define	OBJ_POW10			0xD020
#define	OBJ_POW				0xD021
#define	OBJ_ROOT3			0xD022
#define	OBJ_ROOTXY			0xD023
#define	OBJ_ROUND			0xD024
#define	OBJ_SINH			0xD025
#define	OBJ_SIN				0xD026


#define	OBJ_TANH			0xD029
#define	OBJ_TAN				0xD02a
#define	OBJ_TRUNC			0xD02b
#define	OBJ_VARX			0xD02c
#define	OBJ_POWUP			0xD02d
#define	OBJ_SQR				0xD02e
#define	OBJ_THRE			0xD02f
#define	OBJ_CHALF			0xD030
#define	OBJ_CFOURTH			0xD031
#define	OBJ_CTHRFOUR		0xD032
#define	OBJ_SQRT			0xD033

#define	OBJ_DELETE			0xD040


/* Makro for calculation of object code to table offset in teachtable and keyboard icons */
#define OWNKEYB_OBJTOOFFS(x)	((x) & 0x003f)

/* Makro for checking keyboard object codes in range of teachtable and keyboard icons */
#define OWNKEYB_INRANGE(x)		(((x) >= OBJ_FAK) && ((x) <= OBJ_SQRT))


/* exported data */
extern TCHTBL FAR	TchOwnKeyboardList[];			/* Teachtable for own keyboard */
extern TCHTBL FAR	TchOwnKeyboardListNumEdit[];	/* Teachtable for own keyboard for numbers (without x) */

extern T_ICON FAR	TIconDelete;					/* Icondescription for own keyboard Icons */
extern T_ICON FAR	TIconOwnKeyboard[];				/* Icondescription for own keyboard Icons */

extern byte FAR		GraphOwnKeyboard[];				/* Graphics of own keyboard */


#endif /* _OWNKEYB_H */