/********************************************************************************
* Plotter Surface for drawing mathematical formulas								*
*																				*
* by Ansgar Schfer, (c)2002													*
*																				*
* PVPlGrph.h																	*
*																				*
*																				*
* Version:	V3.00																*
* Date:		09.11.2002															*
********************************************************************************/


#ifndef _PVPLGRPH_H
#define _PVPLGRPH_H


#include "modeldef.h"

#include "buttons.h"
#include "graphlib.h"


#define AX						0			/* start x-position of grid */
#define BX						(AX+GRID_DX)		/* end x-position of grid */
#define AY						8			/* start y-position of grid */
#define BY						(AY+GRID_DY)		/* end y-position of grid */

#define MARKGRAPHSIZE			2			/* half size of the pointmark in plot */

#define EDITMODE_CLR_XPOS		(FUNC_CHANGE_XPOS - 20)
#define EDITMODE_CLR_YPOS		0
#define EDITMODE_PLOT_XPOS		(EDITMODE_CLR_XPOS - 25)
#define EDITMODE_PLOT_YPOS		0
#define EDITMODE_INFO_XPOS		(EDITMODE_PLOT_XPOS - 14)
#define EDITMODE_INFO_YPOS		0

#define SETUPMODE_ESC_XPOS		(160 - 21)
#define SETUPMODE_ESC_YPOS		0
#define SETUPMODE_CLR_XPOS		(SETUPMODE_ESC_XPOS - 20)
#define SETUPMODE_CLR_YPOS		0
#define SETUPMODE_OK_XPOS		(SETUPMODE_CLR_XPOS - 20)
#define SETUPMODE_OK_YPOS		0
#define SETUPMODE_SAVE_XPOS		(SETUPMODE_OK_XPOS - 27)
#define SETUPMODE_SAVE_YPOS		0

#define SETUPMODE_NUM_XPOS		20
#define SETUPMODE_NUM_YPOS		23
#define SETUPMODE_NUM_YSPACE	15

#define SETUPMODE_FM_XPOS		35
#define SETUPMODE_FM_YPOS		99
#define SETUPMODE_FM_YSPACE		14		
#define SETUPMODE_FSHOW_XPOS	80
#define SETUPMODE_FDX_XPOS		120


/**********************************************************************************
 * Unique object codes for user touch icons
 **********************************************************************************/

/****** PlotMode */

#define OBJ_PAPER			(OBJ_OWNESC + 1)
#define OBJ_HEADER			(OBJ_PAPER + 1)

/****** EditMode */
#define	OBJ_STRING			(OBJ_HEADER + 1)

/****** SetupMode */
#define OBJ_XMIN			(OBJ_STRING + 1)
#define OBJ_XMAX			(OBJ_XMIN + 1)
#define OBJ_YMIN			(OBJ_XMAX + 1)
#define OBJ_YMAX			(OBJ_YMIN + 1)
#define OBJ_SHOWF1			(OBJ_YMAX + 1)
#define OBJ_SHOWF2			(OBJ_SHOWF1 + 1)
#define OBJ_SHOWF3			(OBJ_SHOWF2 + 1)
#define OBJ_DRAWFDX1		(OBJ_SHOWF3 + 1)
#define OBJ_DRAWFDX2		(OBJ_DRAWFDX1 + 1)
#define OBJ_DRAWFDX3		(OBJ_DRAWFDX2 + 1)
#define OBJ_SAVE			(OBJ_DRAWFDX3 + 1)


/****** Help window */
#define ENDOFWINDOW	-1
#define ENDOFHELP	-2

typedef struct TINFOLINE
{
	char	*text;
	INT16	ypos;
	byte	font;
} tInfoLine;

/* exported data */

/****** Help window */
extern tInfoLine Help[];

/****** PlotMode */
extern TCHTBL FAR	TchPlotModeList [];

/****** EditMode */
extern TCHTBL FAR	TchEditModeList [];
extern TCHTBL FAR	TchEditXMINModeList [];
extern TCHTBL FAR	TchEditXMAXModeList [];
extern TCHTBL FAR	TchEditYMINModeList [];
extern TCHTBL FAR	TchEditYMAXModeList [];
extern T_ICON FAR	TIconInfo;
extern T_ICON FAR	TIconClr;
extern T_ICON FAR	TIconPlot;

/****** SetupMode */
extern TCHTBL FAR	TchSetupModeList [];
extern T_ICON FAR	TXMinIcon;
extern T_ICON FAR	TXMaxIcon;
extern T_ICON FAR	TYMinIcon;
extern T_ICON FAR	TYMaxIcon;
extern T_ICON FAR	TIconShowF [];
extern T_ICON FAR	TIconDrawFDX [];
extern T_ICON FAR	TSaveIcon;

/****** EditNumbers */
extern TCHTBL FAR	TchEdNumList [];
extern T_ICON FAR	TOKIcon;
extern T_ICON FAR	TEscIcon;
extern T_ICON FAR	TClrIcon;


/****** Edit */
extern word			EditMenuIndexArray[];
extern word			SystMenuIndexArray[];
extern word			OptsMenuIndexArray[];

#endif /* _PVPLGRPH_H */
