/********************************************************************************
* Plotter Surface for drawing mathematical formulas								*
*																				*
* by Ansgar Schfer, (c)2002, original code by Martin Rezab						*
*																				*
* PVplot.h																		*
*																				*
* Contains Display constants and Graphics										*
*																				*
* Version:	V3.07																*
* Date:		09.11.2002															*
********************************************************************************/


#ifndef _PVPLOT_H
#define _PVPLOT_H

#include "modeldef.h"

#include "Dummy.h"

/* define for a comment on Extremas */
#define	EXTREMAANALYSIS
/* #undef	EXTREMAANALYSIS */

/* define for rescaling after zero crossing detection instead of just marking */
#define RESCALEONZEROCROSSING
#undef RESCALEONZEROCROSSING

/* define for a litle cross at undefined value */
#define CROSSFORUNDEFINED
/* #undef CROSSFORUNDEFINED */


#include "Parser.h"

#include "xpanel.h"
#include "ypanel.h"
#include "ownkeyb.h"

#include "PVPlgrph.h"

#include "sharedlib.h"

/**********************************************************************************
 * Constants
 **********************************************************************************/

#define MODE_EXIT	0
#define MODE_EDIT	1
#define MODE_PLOT	2
#define MODE_SETUP	3

#define NumFormulas	3

#define PVPLOTSHAREDID		"PVPlot"
#define	PVPLOTFORMULAID		"Form"
#define	PVPLOTDRAWFXID		"DrFX"
#define PVPLOTSHOWID		"Show"
#define PVPLOTLIMITSID		"Lim"

#define TITLE				"PVPlot V3.09"
#define INI_FORMULA			"sin(2*pi*x)*x+x/2"

typedef struct TDISPFORMULA {
	tFormula FAR	*Formula;			/* Formula				*/
	unsigned INT8	Show;				/* Flag for visible		*/
	unsigned INT8	Drawfx;				/* Flag to show f(x)	*/
	byte FAR		*Icon;				/* Icon for Formula		*/
} tDispFormula;

typedef struct TCALCY {
/*	double y1;
	double y2;*/
	double y3;
	double y4;
	double dy21;
	double dy32;
	double dy43;
	GRAPHCOORDTYPE sy;
	GRAPHCOORDTYPE ny;
/*	INT8	err1; */
	INT8	err2;
	INT8	err3;
	INT8	err4;
} tCalcY;

#endif /* _PVPLOT_H */
