/********************************************************************************
* Plotter Surface for drawing mathematical formulas								*
*																				*
* by Ansgar Schfer, (c)2002													*
*																				*
* PVPlGrph.c																	*
*																				*
*																				*
* Version:	V3.00																*
* Date:		09.11.2002															*
********************************************************************************/


#include "PVPlGrph.h"



/**********************************************************************************
 * Touch table
 **********************************************************************************/

/****** PlotMode */
TCHTBL FAR	TchPlotModeList [] = 
{	
	AX,		AY,		BX,					BY,		(ACT_MAKE | ACT_MOVE_IN | ACT_DOWN_IN | ACT_BREAK | ACT_BREAK_IN),	OBJ_PAPER,			0x0000,
	0,		0,		FUNC_CHANGE_XPOS-1,	AY-1,	(ACT_MAKE | ACT_DOWN_IN),											OBJ_HEADER,			0x0000,

	0,		0,		0,					0,		ACT_NONE,															OBJ_END,			0x0000
};

/****** EditMode */
TCHTBL FAR	TchEditModeList [] = 
{
	EDITMODE_INFO_XPOS+1,	EDITMODE_INFO_YPOS+1,	EDITMODE_INFO_XPOS+11,	EDITMODE_INFO_YPOS+10,	ACT_ICON,	OBJ_INFO,			0x0000,
	EDITMODE_CLR_XPOS+1,	EDITMODE_CLR_YPOS+1,	EDITMODE_CLR_XPOS+17,	EDITMODE_CLR_YPOS+10,	ACT_ICON,	OBJ_CLR,			0x0000,
	EDITMODE_PLOT_XPOS+1,	EDITMODE_PLOT_YPOS+1,	EDITMODE_PLOT_XPOS+22,	EDITMODE_PLOT_YPOS+10,	ACT_ICON,	OBJ_PLOT,			0x0000,

	FUNC_CHANGE_XPOS+1,		FUNC_CHANGE_YPOS+1,		FUNC_CHANGE_XPOS+12,	FUNC_CHANGE_YPOS+10,	ACT_ICON,	OBJ_FUNC_CHANGE,	0x0000,

	0,						0,						0,						0,						ACT_NONE,	OBJ_END,			0x0000
};

TCHTBL FAR	TchEditXMINModeList [] = 
{
	SETUPMODE_NUM_XPOS+1,	SETUPMODE_NUM_YPOS+0*SETUPMODE_NUM_YSPACE+1,	SETUPMODE_NUM_XPOS+28,	SETUPMODE_NUM_YPOS+0*SETUPMODE_NUM_YSPACE+10,	ACT_ICON,	OBJ_XMIN,		0x0000,
	0,						0,						0,						0,						ACT_NONE,	OBJ_END,			0x0000
};
TCHTBL FAR	TchEditXMAXModeList [] = 
{
	SETUPMODE_NUM_XPOS+1,	SETUPMODE_NUM_YPOS+1*SETUPMODE_NUM_YSPACE+1,	SETUPMODE_NUM_XPOS+28,	SETUPMODE_NUM_YPOS+1*SETUPMODE_NUM_YSPACE+10,	ACT_ICON,	OBJ_XMAX,		0x0000,
	0,						0,						0,						0,						ACT_NONE,	OBJ_END,			0x0000
};
TCHTBL FAR	TchEditYMINModeList [] = 
{
	SETUPMODE_NUM_XPOS+1,	SETUPMODE_NUM_YPOS+2*SETUPMODE_NUM_YSPACE+1,	SETUPMODE_NUM_XPOS+28,	SETUPMODE_NUM_YPOS+2*SETUPMODE_NUM_YSPACE+10,	ACT_ICON,	OBJ_YMIN,		0x0000,
	0,						0,						0,						0,						ACT_NONE,	OBJ_END,			0x0000
};
TCHTBL FAR	TchEditYMAXModeList [] = 
{
	SETUPMODE_NUM_XPOS+1,	SETUPMODE_NUM_YPOS+3*SETUPMODE_NUM_YSPACE+1,	SETUPMODE_NUM_XPOS+28,	SETUPMODE_NUM_YPOS+3*SETUPMODE_NUM_YSPACE+10,	ACT_ICON,	OBJ_YMAX,		0x0000,
	0,						0,						0,						0,						ACT_NONE,	OBJ_END,			0x0000
};


/****** SetupMode */
TCHTBL FAR	TchSetupModeList [] = 
{
	SETUPMODE_NUM_XPOS+1,	SETUPMODE_NUM_YPOS+0*SETUPMODE_NUM_YSPACE+1,	SETUPMODE_NUM_XPOS+28,	SETUPMODE_NUM_YPOS+0*SETUPMODE_NUM_YSPACE+10,	ACT_ICON,	OBJ_XMIN,		0x0000,
	SETUPMODE_NUM_XPOS+1,	SETUPMODE_NUM_YPOS+1*SETUPMODE_NUM_YSPACE+1,	SETUPMODE_NUM_XPOS+28,	SETUPMODE_NUM_YPOS+1*SETUPMODE_NUM_YSPACE+10,	ACT_ICON,	OBJ_XMAX,		0x0000,
	SETUPMODE_NUM_XPOS+1,	SETUPMODE_NUM_YPOS+2*SETUPMODE_NUM_YSPACE+1,	SETUPMODE_NUM_XPOS+28,	SETUPMODE_NUM_YPOS+2*SETUPMODE_NUM_YSPACE+10,	ACT_ICON,	OBJ_YMIN,		0x0000,
	SETUPMODE_NUM_XPOS+1,	SETUPMODE_NUM_YPOS+3*SETUPMODE_NUM_YSPACE+1,	SETUPMODE_NUM_XPOS+28,	SETUPMODE_NUM_YPOS+3*SETUPMODE_NUM_YSPACE+10,	ACT_ICON,	OBJ_YMAX,		0x0000,

	SETUPMODE_FSHOW_XPOS-1,	SETUPMODE_FM_YPOS+1*SETUPMODE_FM_YSPACE-1,		SETUPMODE_FSHOW_XPOS+8,	SETUPMODE_FM_YPOS+1*SETUPMODE_FM_YSPACE+8,		ACT_ICON,	OBJ_SHOWF1,		0x0000,
	SETUPMODE_FSHOW_XPOS-1,	SETUPMODE_FM_YPOS+2*SETUPMODE_FM_YSPACE-1,		SETUPMODE_FSHOW_XPOS+8,	SETUPMODE_FM_YPOS+2*SETUPMODE_FM_YSPACE+8,		ACT_ICON,	OBJ_SHOWF2,		0x0000,
	SETUPMODE_FSHOW_XPOS-1,	SETUPMODE_FM_YPOS+3*SETUPMODE_FM_YSPACE-1,		SETUPMODE_FSHOW_XPOS+8,	SETUPMODE_FM_YPOS+3*SETUPMODE_FM_YSPACE+8,		ACT_ICON,	OBJ_SHOWF3,		0x0000,

	SETUPMODE_FDX_XPOS-1,	SETUPMODE_FM_YPOS+1*SETUPMODE_FM_YSPACE-1,		SETUPMODE_FDX_XPOS+8,	SETUPMODE_FM_YPOS+1*SETUPMODE_FM_YSPACE+8,		ACT_ICON,	OBJ_DRAWFDX1,	0x0000,
	SETUPMODE_FDX_XPOS-1,	SETUPMODE_FM_YPOS+2*SETUPMODE_FM_YSPACE-1,		SETUPMODE_FDX_XPOS+8,	SETUPMODE_FM_YPOS+2*SETUPMODE_FM_YSPACE+8,		ACT_ICON,	OBJ_DRAWFDX2,	0x0000,
	SETUPMODE_FDX_XPOS-1,	SETUPMODE_FM_YPOS+3*SETUPMODE_FM_YSPACE-1,		SETUPMODE_FDX_XPOS+8,	SETUPMODE_FM_YPOS+3*SETUPMODE_FM_YSPACE+8,		ACT_ICON,	OBJ_DRAWFDX3,	0x0000,

	SETUPMODE_SAVE_XPOS+1,	SETUPMODE_SAVE_YPOS+1,							SETUPMODE_SAVE_XPOS+22,	SETUPMODE_SAVE_YPOS+10,							ACT_ICON,	OBJ_SAVE,		0x0000,

	0,						0,												0,						0,												ACT_NONE,	OBJ_END,		0x0000
};

/****** EditNumbers */
TCHTBL FAR	TchEdNumList [] = 
{
	SETUPMODE_OK_XPOS+1,	SETUPMODE_OK_YPOS+1,	SETUPMODE_OK_XPOS+17,	SETUPMODE_OK_YPOS+10,	ACT_ICON,	OBJ_OK,			0x0000,
	SETUPMODE_CLR_XPOS+1,	SETUPMODE_CLR_YPOS+1,	SETUPMODE_CLR_XPOS+19,	SETUPMODE_CLR_YPOS+10,	ACT_ICON,	OBJ_CLR,		0x0000,
	SETUPMODE_ESC_XPOS+1,	SETUPMODE_ESC_YPOS+1,	SETUPMODE_ESC_XPOS+19,	SETUPMODE_ESC_YPOS+10,	ACT_ICON,	OBJ_OWNESC,		0x0000,

	0,						0,						0,						0,						ACT_NONE,	OBJ_END,		0x0000
};


/**********************************************************************************
 * Assignment of place, picture and action to an icon
 **********************************************************************************/

/****** EditMode */
T_ICON FAR	TIconInfo		= { &TchEditModeList[0x00],		NULL, NULL, 0x03 };
T_ICON FAR	TIconClr		= { &TchEditModeList[0x01],		NULL, NULL, 0x03 };
T_ICON FAR	TIconPlot		= { &TchEditModeList[0x02],		NULL, NULL, 0x03 };

/****** SetupMode */
T_ICON FAR	TXMinIcon		= { &TchSetupModeList[0x00],	NULL, NULL, 0x03 };
T_ICON FAR	TXMaxIcon		= { &TchSetupModeList[0x01],	NULL, NULL, 0x03 };
T_ICON FAR	TYMinIcon		= { &TchSetupModeList[0x02],	NULL, NULL, 0x03 };
T_ICON FAR	TYMaxIcon		= { &TchSetupModeList[0x03],	NULL, NULL, 0x03 };
T_ICON FAR	TIconShowF []	= {
								{ &TchSetupModeList[0x04],	NULL, NULL, 0x03 },
								{ &TchSetupModeList[0x05],	NULL, NULL, 0x03 },
								{ &TchSetupModeList[0x06],	NULL, NULL, 0x03 }
};
T_ICON FAR	TIconDrawFDX [] = {
								{ &TchSetupModeList[0x07],	NULL, NULL, 0x03 },
								{ &TchSetupModeList[0x08],	NULL, NULL, 0x03 },
								{ &TchSetupModeList[0x09],	NULL, NULL, 0x03 }
};
T_ICON FAR	TSaveIcon		= { &TchSetupModeList[0x0a],	NULL, NULL, 0x03 };

/****** EditNumbers */
T_ICON FAR	TOKIcon			= { &TchEdNumList[0x00],		NULL, NULL, 0x03 };
T_ICON FAR	TClrIcon		= { &TchEdNumList[0x01],		NULL, NULL, 0x03 };
T_ICON FAR	TEscIcon		= { &TchEdNumList[0x02],		NULL, NULL, 0x03 };


/**********************************************************************************
 * Menu items
 **********************************************************************************/

/* For indexes of menu items see MESSAGE.TXT */

/****** Edit */
word EditMenuIndexArray[] = { 20, 21, 22, PDNTBLEND }; 
word SystMenuIndexArray[] = { PDNTBLEND };
word OptsMenuIndexArray[] = { PDNTBLEND };


/****** Help window */

char Help01[]	= "Program for drawing ma-";
char Help02[]	= "thematical functions.";
char Help03[]	= "Graph can be zoomed and";
char Help04[]	= "moved as needed.";
char Help05[]	= "Allows drawing of up to";
char Help06[]	= "3 functions and their";
char Help07[]	= "derivatives.";
char Help08[]	= "Search for zero cros-";
char Help09[]	= "sing with [z] button in";
char Help10[]	= "graph display.";

char Help11[]	= "Optimized for display";
char Help12[]	= "speed, so not allways";
char Help13[]	= "correct...";
char Help14[]	= "Derivative and zero";
char Help15[]	= "crossing are calculated";
char Help16[]	= "numerically only...";
char Help17[]	= "Keep brain activated";
char Help18[]	= "while using!";

char Help20[]	= "Known functions are:";
char Help21[]	= "abs, acos, asin, atan,";
char Help22[]	= "cosh, cos, exp, fak, ln,";
char Help23[]	= "log10, log, pow10, pow,";
char Help24[]	= "root, root3, round, sinh,";
char Help25[]	= "sin, sqrt, sqr, tanh,";
char Help26[]	= "tan and trunc.";

char Help30[]	= "Known constants are:";
char Help31[]	= {' ',' ',' ',' ','e',' ','p','i',' ',0xC9,' ',0xCA,' ',0xCB,' ',0};
char Help32[]	= "Valid operators are:";
char Help33[]	= {' ','!',' ','(',' ',')',' ','*',' ','+',' ','-',' ','/',' ','^',' ',0xC6,' ',0xC7,' ',0xD1,0};
char Help34[]	= "Examples:";
char Help35[]	= {'x',0xC6,',',' ','l','n','(','s','i','n','(','x',')',')',',',' ','2','*','e',' ','e','t','c','.',0};
char Help36[]	= "   Function variable";
char Help37[]	= "         is x";

char Help40[]	= "MatySoft (c) 2001,";
char Help41[]	= {'A','n','s','g','a','r',' ','S','c','h',0xB0,'f','e','r',' ','(','c',')',' ','2','0','0','3',0};
char Help42[]	= "Now ported to PV-S1600,";
char Help43[]	= "too. Really fast on the";
char Help44[]	= "PV-S1600... :o)";
char Help45[]	= "Greetings to all on";
char Help46[]	= "www.pocketviewer.de";
char Help47[]	= "You can use PVPlot for";
char Help48[]	= "free.";

char Help50[]	= "Please mail comments,";
char Help51[]	= "suggestions and bugs.";
char Help52[]	= "mailto:";
char Help53[]	= " ansgar.pvplot@gmx.de";
char Help54[]	= "Hope no bugs left... ;o)";
char Help55[]	= "Leave this screen with";
char Help56[]	= "[Esc] to remove shared";
char Help57[]	= "file data. Or...";


tInfoLine Help[] =
{
	{Help01, 35, IB_PFONT1},
	{Help02, 44, IB_PFONT1},
	{Help03, 54, IB_PFONT1},
	{Help04, 63, IB_PFONT1},
	{Help05, 72, IB_PFONT1},
	{Help06, 81, IB_PFONT1},
	{Help07, 90, IB_PFONT1},
	{Help08, 99, IB_PFONT1},
	{Help09, 108, IB_PFONT1},
	{Help10, 117, IB_PFONT1},
	{NULL, ENDOFWINDOW, 0},

	{Help11, 35, IB_PFONT1},
	{Help12, 44, IB_PFONT1},
	{Help13, 53, IB_PFONT1},
	{Help14, 64, IB_PFONT1},
	{Help15, 73, IB_PFONT1},
	{Help16, 82, IB_PFONT1},
	{Help17, 98, IB_PFONT2},
	{Help18, 107, IB_PFONT2},
	{NULL, ENDOFWINDOW, 0},

	{Help20, 35, IB_PFONT1},
	{Help21, 47, IB_PFONT1},
	{Help22, 57, IB_PFONT1},
	{Help23, 67, IB_PFONT1},
	{Help24, 77, IB_PFONT1},
	{Help25, 87, IB_PFONT1},
	{Help26, 97, IB_PFONT1},
	{NULL, ENDOFWINDOW, 0},

	{Help30, 35, IB_PFONT1},
	{Help31, 45, IB_PFONT1},
	{Help32, 56, IB_PFONT1},
	{Help33, 66, IB_PFONT1},
	{Help34, 78, IB_PFONT1},
	{Help35, 88, IB_PFONT1},
	{Help36, 105, IB_PFONT2},
	{Help37, 115, IB_PFONT2},
	{NULL, ENDOFWINDOW, 0},

	{Help40, 35, IB_PFONT1},
	{Help41, 44, IB_PFONT1},
	{Help42, 55, IB_PFONT1},
	{Help43, 64, IB_PFONT1},
	{Help44, 73, IB_PFONT1},
	{Help45, 84, IB_PFONT1},
	{Help46, 95, IB_PFONT2},
	{Help47, 107, IB_PFONT1},
	{Help48, 116, IB_PFONT1},
	{NULL, ENDOFWINDOW, 0},

	{Help50, 35, IB_PFONT1},
	{Help51, 44, IB_PFONT1},
	{Help52, 59, IB_PFONT1},
	{Help53, 71, IB_PFONT1},
	{Help54, 85, IB_PFONT1},
	{Help55, 99, IB_PFONT1},
	{Help56, 108, IB_PFONT1},
	{Help57, 117, IB_PFONT1},
	{NULL, ENDOFHELP, 0}
};